unit compat;

interface
        procedure _putpixel (x, y : word; c : byte);
        procedure _delay (ms : word);
        procedure _line (x1, y1, x2, y2 : word; c : byte);
        procedure _setpal (i, r, g, b : byte);
	procedure _getpal (i : byte; var r, g, b : byte);
	procedure _readpal;
        procedure _setmcga;
	procedure _settext;
        procedure _filledrect (x1, y1, x2, y2 : word; c : byte);
	procedure _cls;
	procedure _retrace;

	function _getpixel (x, y : word) : byte;
	function _sin (x : real) : real;
	function _cos (x : real) : real;

implementation


uses
	graph, crt;

procedure _putpixel (x, y : word; c : byte);
begin
        putpixel (x, y, c);
end;

procedure _delay (ms : word);
begin
        delay (ms);
end;

procedure _line (x1, y1, x2, y2 : word; c : byte);
begin
	setcolor (c);
        line (x1, y1, x2, y2);
end;

procedure _setpal (i, r, g, b : byte);
begin
        setrgbpalette (i, r * 4, g * 4, b * 4);
end;

procedure _getpal (i : byte; var r, g, b : byte);
begin
	r := 100;
	g := 100;
	b := 100;
end;

procedure _readpal;
begin
	(* dummy *)
end;

procedure _setmcga;
var
	gr, gm : integer;
begin
	gr := d8bit;
	gm := m320x200;
        initgraph (gr, gm, '');
end;

procedure _filledrect (x1, y1, x2, y2 : word; c : byte);
var
        x, y : word;
begin
        for x := x1 to x2 do
                for y := y1 to y2 do
                        _putpixel (x, y, c);
end;

procedure _settext;
begin
	closegraph;
end;


procedure _cls;
begin
	cleardevice;
end;

procedure _retrace;
begin
	(* dummy *)
end;

function _getpixel (x, y : word) : byte;
begin
	_getpixel := getpixel (x, y);
end;

function _sin (x : real) : real;
begin
	_sin := sin (pi + (x / 180) * pi);
end;

function _cos (x : real) : real;
begin
	_cos := cos (pi + (x / 180) * pi);
end;

begin
end.
