unit fonts;

interface
       function value (st : string) : integer;
       function strn (i : longint) : string;
       procedure dig_font_print (x, y : word; st : string);
       procedure small_font_print (x, y : word; st : string);
       procedure load_dig_font (name : string);
       procedure load_small_font (name : string);
implementation

uses compat;

var
        y, x, c  : byte;
        ch_num   : byte;
        st       : string;
        fontfile : text;
        font     : array [1..10, 1..7, 1..7] of byte;
        small    : array [1..46, 1..4, 1..5] of byte;

function value (st : string) : integer;
var
        i, code : integer;
begin
        val (st, i, code);
        value := i;
end;

function strn (i : longint) : string;
var
        st : string;
begin
        str (i, st);
        strn := st;
end;

procedure draw_digit (x, y : word; i : byte);
var
        xx, yy : byte;
begin
        for xx := 1 to 7 do
                for yy := 1 to 7 do
                        if (font [i, xx, yy] <> 0) then
                                _putpixel (x + xx, y + yy, font [i, xx, yy]);
end;

procedure draw_char (x, y : word; i : byte);
var
        xx, yy : byte;
begin
        for xx := 1 to 4 do
                for yy := 1 to 5 do
                        if (small [i, xx, yy] <> 0) then
                                _putpixel (x + xx, y + yy, small [i, xx, yy]);
end;


procedure dig_font_print (x, y : word; st : string);
var
        xx : byte;
begin
        for xx := 1 to length (st) do begin
                if st [xx] = '0' then
                        draw_digit (x + (xx - 1) * 7, y, 10)
                else
                        draw_digit (x + (xx - 1) * 7, y, value (st [xx]));
        end;
end;

procedure small_font_print (x, y : word; st : string);
var
        xx : byte;
begin
        for xx := 1 to length (st) do begin
                if st [xx] = '0' then
                        draw_char (x + (xx - 1) * 5, y, 10)
                else if st [xx] = '.' then
                        draw_char (x + (xx - 1) * 5, y, 11)
                else if st [xx] = ',' then
                        draw_char (x + (xx - 1) * 5, y, 38)
                else if st [xx] = '''' then
                        draw_char (x + (xx - 1) * 5, y, 39)
                else if st [xx] = '-' then
                        draw_char (x + (xx - 1) * 5, y, 40)
                else if st [xx] = ':' then
                        draw_char (x + (xx - 1) * 5, y, 41)
                else if st [xx] = '!' then
                        draw_char (x + (xx - 1) * 5, y, 42)
                else if st [xx] = '' then
                        draw_char (x + (xx - 1) * 5, y, 43)
                else if st [xx] = '' then
                        draw_char (x + (xx - 1) * 5, y, 44)
                else if st [xx] = '' then
                        draw_char (x + (xx - 1) * 5, y, 45)
                else if st [xx] = '@' then
                        draw_char (x + (xx - 1) * 5, y, 46)
                else if (ord (st [xx]) >= 65) then
                        draw_char (x + (xx - 1) * 5, y, 12 + (ord (st [xx]) - 65))
                else if st [xx] <> ' ' then
                        draw_char (x + (xx - 1) * 5, y, value (st [xx]));
        end;
end;

procedure load_dig_font (name : string);
begin
        ch_num := 0;
        assign (fontfile, name);
        reset (fontfile);
        while (not eof (fontfile)) do begin
                inc (ch_num);
                for y := 1 to 7 do begin
                        readln (fontfile, st);
                        for x := 1 to length (st) do begin
                                if (st [x] = '1') then
                                        c := 254
                                else if (st [x] = '2') then
                                        c := 255
                                else
                                        c := value (st [x]);
                                font [ch_num, x, y] := c;
                        end;
                end;
        end;
        close (fontfile);
end;

procedure load_small_font (name : string);
begin
        ch_num := 0;
        assign (fontfile, name);
        reset (fontfile);
        while (not eof (fontfile)) do begin
                inc (ch_num);
                for y := 1 to 5 do begin
                        readln (fontfile, st);
                        for x := 1 to length (st) do begin
                                if (st [x] = '1') then
                                        c := 253
                                else if (st [x] = '2') then
                                        c := 252
                                else
                                        c := value (st [x]);
                                small [ch_num, x, y] := c;
                        end;
                end;
        end;
        close (fontfile);
end;

begin
end.
